diff a/src/jdk.incubator.code/share/classes/jdk/incubator/code/extern/DialectFactory.java b/src/jdk.incubator.code/share/classes/jdk/incubator/code/extern/DialectFactory.java
--- /dev/null
+++ b/src/jdk.incubator.code/share/classes/jdk/incubator/code/extern/DialectFactory.java
@@ -0,0 +1,15 @@
+package jdk.incubator.code.extern;
+
+/**
+ * A dialect factory for constructing a dialect's operations and type elements from their
+ * externalized form.
+ *
+ * @param opFactory the operation factory.
+ * @param typeElementFactory the type element factory.
+ */
+public record DialectFactory(OpFactory opFactory, TypeElementFactory typeElementFactory) {
+
+    // OpFactory
+    // OpDeclaration
+    // TypeElementFactory
+}
